[openwrt/openwrt] ltq-vdsl-vr11-app: add version 4.23.1 for vr11 targets

LEDE Commits lede-commits at lists.infradead.org
Mon Jan 16 15:42:38 PST 2023


dangole pushed a commit to openwrt/openwrt.git, branch master:
https://git.openwrt.org/6e4c9738bed0ac99d048e71596b716d0819375b2

commit 6e4c9738bed0ac99d048e71596b716d0819375b2
Author: Martin Schiller <ms.3headeddevs at gmail.com>
AuthorDate: Wed Aug 21 09:00:08 2019 +0200

    ltq-vdsl-vr11-app: add version 4.23.1 for vr11 targets
    
    This uses version 4.23.1 of the dsl_cpe_control package from the Intel
    UGW 8.5.2.10 for the VRX518.
    
    Signed-off-by: Martin Schiller <ms.3headeddevs at gmail.com>
    [rebased]
    Signed-off-by: Jan Hoffmann <jan at 3e8.eu>
    [update to 4.23.1, added Jan's vector mac patch, fix warnings,
     switch to tag tarball]
    Signed-off-by: Andre Heider <a.heider at gmail.com>
    [add missing nLine in autoboot script, fix disconnect on termination,
     remove unneeded VR9 leftovers in init script]
    Signed-off-by: Jan Hoffmann <jan at 3e8.eu>
    Signed-off-by: Andre Heider <a.heider at gmail.com>
---
 package/network/config/ltq-vdsl-vr11-app/Makefile  |  92 +++++++
 .../config/ltq-vdsl-vr11-app/files/dsl_control     | 264 +++++++++++++++++++++
 .../config/ltq-vdsl-vr11-app/files/dsl_cpe_pipe.sh |  18 ++
 .../ltq-vdsl-vr11-app/patches/100-compat.patch     |  11 +
 .../ltq-vdsl-vr11-app/patches/101-warnings.patch   |  87 +++++++
 .../ltq-vdsl-vr11-app/patches/200-autoboot.patch   |  85 +++++++
 .../ltq-vdsl-vr11-app/patches/300-ubus.patch       |  50 ++++
 7 files changed, 607 insertions(+)

diff --git a/package/network/config/ltq-vdsl-vr11-app/Makefile b/package/network/config/ltq-vdsl-vr11-app/Makefile
new file mode 100644
index 0000000000..8639795458
--- /dev/null
+++ b/package/network/config/ltq-vdsl-vr11-app/Makefile
@@ -0,0 +1,92 @@
+# Copyright (C) 2010 OpenWrt.org
+# Copyright (C) 2015-2016 Lantiq Beteiligungs GmbH & Co KG.
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+
+include $(TOPDIR)/rules.mk
+include $(INCLUDE_DIR)/kernel.mk
+
+PKG_NAME:=ltq-vdsl-vr11-app
+PKG_VERSION:=4.23.1
+PKG_RELEASE:=1
+PKG_BASE_NAME:=dsl_cpe_control
+
+UGW_VERSION=8.5.2.10
+UGW_BASENAME=$(PKG_BASE_NAME)-ugw_$(UGW_VERSION)
+
+PKG_SOURCE:=$(UGW_BASENAME).tar.bz2
+PKG_SOURCE_URL:=https://gitlab.com/prpl-foundation/intel/$(PKG_BASE_NAME)/-/archive/ugw_$(UGW_VERSION)/
+PKG_HASH:=d21ec74ca30f7f3893a8aa26d2b74ec319652f6b112832efab6f1274c7e5d1fc
+PKG_BUILD_DIR:=$(BUILD_DIR)/$(UGW_BASENAME)
+PKG_LICENSE:=BSD-2-Clause
+PKG_LICENSE_FILES:=LICENSE
+
+PKG_BUILD_DEPENDS:=ltq-vdsl-vr11
+
+PKG_FLAGS:=nonshared
+PKG_FIXUP:=autoreconf
+
+include $(INCLUDE_DIR)/package.mk
+
+define Package/ltq-vdsl-vr11-app
+  SECTION:=net
+  CATEGORY:=Network
+  TITLE:=Lantiq VDSL userland tool
+  URL:=http://www.lantiq.com/
+  DEPENDS:=@TARGET_ipq40xx +libpthread +librt +libubox +libubus +ltq-dsl-base +kmod-ltq-vdsl-vr11
+  PROVIDES:=ltq-dsl-app
+endef
+
+define Package/ltq-vdsl-vr11-app/description
+  Userland tool needed to control Lantiq VDSL CPE
+endef
+
+# ltq-vdsl-vr11-app uses a header provided by the MEI driver which has some
+# conditionals.
+#
+# Define them here with the default values they would get in the MEI driver,
+# have the same view on both sides.
+#
+# If you change them, you need to change them for the ltq-vdsl-vr11-app as well
+VDSL_APP_CFLAGS = \
+	-DMAX_CLI_PIPES=1 \
+	-DMEI_SUPPORT_DEBUG_STREAMS=1 \
+	-DMEI_SUPPORT_OPTIMIZED_FW_DL=1
+
+CONFIGURE_ARGS += \
+	--enable-debug-logger-support=no
+
+CONFIGURE_ARGS += \
+	--enable-vrx \
+	--enable-vrx-device=vr11 \
+	--enable-driver-include="-I$(STAGING_DIR)/usr/include/drv_vdsl_cpe_api" \
+	--enable-device-driver-include="-I$(STAGING_DIR)/usr/include/vdsl/" \
+	--enable-ifxos \
+	--enable-ifxos-include="-I$(STAGING_DIR)/usr/include/ifxos" \
+	--enable-ifxos-library="-I$(STAGING_DIR)/usr/lib" \
+	--enable-add-appl-cflags="$(VDSL_APP_CFLAGS)"  \
+	--enable-debug \
+	--disable-dti
+
+CONFIGURE_ARGS += \
+	--enable-model=full \
+	--enable-dsl-ceoc=no
+#CONFIGURE_ARGS += --enable-model=lite
+#CONFIGURE_ARGS += --enable-model=footprint
+#CONFIGURE_ARGS += --enable-model=typical
+#CONFIGURE_ARGS += --enable-model=debug
+
+define Build/Prepare
+	$(call Build/Prepare/Default)
+	$(CP) ../ltq-vdsl-vr9-app/src/src/dsl_cpe_ubus.c $(PKG_BUILD_DIR)/src/
+endef
+
+define Package/ltq-vdsl-vr11-app/install
+	$(INSTALL_DIR) $(1)/etc/init.d $(1)/sbin $(1)/etc/hotplug.d/dsl
+	$(INSTALL_BIN) ./files/dsl_control $(1)/etc/init.d/
+	$(INSTALL_BIN) $(PKG_BUILD_DIR)/src/dsl_cpe_control $(1)/sbin/vdsl_cpe_control
+	$(INSTALL_BIN) ./files/dsl_cpe_pipe.sh $(1)/sbin/
+endef
+
+$(eval $(call BuildPackage,ltq-vdsl-vr11-app))
diff --git a/package/network/config/ltq-vdsl-vr11-app/files/dsl_control b/package/network/config/ltq-vdsl-vr11-app/files/dsl_control
new file mode 100644
index 0000000000..d960a77261
--- /dev/null
+++ b/package/network/config/ltq-vdsl-vr11-app/files/dsl_control
@@ -0,0 +1,264 @@
+#!/bin/sh /etc/rc.common
+# Copyright (C) 2012 OpenWrt.org
+
+START=97
+USE_PROCD=1
+
+dslstat() {
+	ubus call dsl metrics
+}
+
+extra_command "dslstat" "Get DSL status information"
+
+#
+# ITU-T G.997.1 (06/2012) - Section 7.3.1.1.1 (xTU transmission system enabling (XTSE))
+# ITU-T G.997.1 Amendment 2 (04/2013) - Section 2.1 - (Vectoring mode enable (VECTORMODE_ENABLE))
+#
+# G.992.1 Annex A
+# G.992.2 Annex A
+# G.992.3 Annex A / L-US1 / L_US-2 / M
+# G.992.5 Annex A / M
+# G.993.2 Annex A/B/C
+# G.993.5 Annex A/B/C
+xtse_xdsl_a="05_01_04_00_4C_01_04_07"
+
+# G.992.1 Annex B
+# G.992.3 Annex B
+# G.992.5 Annex B
+# G.993.2 Annex A/B/C
+# G.993.5 Annex A/B/C
+xtse_xdsl_b="10_00_10_00_00_04_00_07"
+
+# G.992.1 Annex B
+# G.992.3 Annex B
+# G.992.3 Annex J
+# G.992.5 Annex B
+# G.992.5 Annex J
+# G.993.2 Annex A/B/C
+# G.993.5 Annex A/B/C
+xtse_xdsl_j="10_00_10_40_00_04_01_07"
+
+# G.992.1 Annex B
+xtse_xdsl_bdmt="10_00_00_00_00_00_00_00"
+
+# G.992.3 Annex B
+xtse_xdsl_b2="00_00_10_00_00_00_00_00"
+
+# G.992.5 Annex B
+xtse_xdsl_b2p="00_00_00_00_00_04_00_00"
+
+# ANSI T1.413
+xtse_xdsl_at1="01_00_00_00_00_00_00_00"
+
+# G.992.2 Annex A
+xtse_xdsl_alite="00_01_00_00_00_00_00_00"
+
+# G.992.1 Annex A
+xtse_xdsl_admt="04_00_00_00_00_00_00_00"
+
+# G.992.3 Annex A
+xtse_xdsl_a2="00_00_04_00_00_00_00_00"
+
+# G.992.5 Annex A
+xtse_xdsl_a2p="00_00_00_00_00_01_00_00"
+
+# G.992.3 Annex L
+xtse_xdsl_l="00_00_00_00_0C_00_00_00"
+
+# G.992.3 Annex M
+# G.992.5 Annex M
+xtse_xdsl_m="00_00_00_00_40_00_04_00"
+
+# G.992.3 Annex M
+xtse_xdsl_m2="00_00_00_00_40_00_00_00"
+
+# G.992.5 Annex M
+xtse_xdsl_m2p="00_00_00_00_00_00_04_00"
+
+#
+# ITU-T G.994.1 (06/2012) - Table 2 (Mandatory carrier sets)
+#
+
+# A43
+tone_adsl_a="0x142" # A43C + J43 + A43
+tone_vdsl_a="0x142" # A43C + J43 + A43
+
+# A43 + V43
+tone_adsl_av="0x142" # A43C + J43 + A43
+tone_vdsl_av="0x146" # A43C + J43 + A43 + V43
+
+# B43
+tone_adsl_b="0x81" # B43 + B43c
+tone_vdsl_b="0x1" # B43
+
+# B43 + V43
+tone_adsl_bv="0x81" # B43 + B43c
+tone_vdsl_bv="0x5" # B43 + V43
+
+# create DSL autoboot script. Used for SNR margin tweak and to set MAC address for vectoring error reports
+autoboot_script() {
+    echo "[WaitForConfiguration]={
+locs nLine=0 0 $1
+dsmmcs nLine=0 $2
+}
+
+[WaitForLinkActivate]={
+}
+
+[WaitForRestart]={
+}
+
+[Common]={
+}" > /tmp/dsl.scr
+}
+
+lowlevel_cfg() {
+	echo "# VRX Low Level Configuration File
+#
+# Parameters must be separated by tabs or spaces.
+# Empty lines and comments will be ignored.
+#
+
+# nFilter
+#
+# NA     = -1
+# OFF    = 0
+# ISDN   = 1
+# POTS   = 2
+# POTS_2 = 3
+# POTS_3 = 4
+#
+#  (dec)
+    -1
+
+# nHsToneGroupMode nHsToneGroup_A       nHsToneGroup_V    nHsToneGroup_AV
+#
+# NA     = -1      NA         = -1      see               see
+# AUTO   = 0       VDSL2_B43  = 0x0001  nHsToneGroup_A    nHsToneGroup_A
+# MANUAL = 1       VDSL2_A43  = 0x0002
+#                  VDSL2_V43  = 0x0004
+#                  VDSL1_V43P = 0x0008
+#                  VDSL1_V43I = 0x0010
+#                  ADSL1_C43  = 0x0020
+#                  ADSL2_J43  = 0x0040
+#                  ADSL2_B43C = 0x0080
+#                  ADSL2_A43C = 0x0100
+#
+#  (dec)           (hex)                (hex)             (hex)
+     1             $1			$2		 0x0
+
+#   nBaseAddr     nIrqNum
+#
+#     (hex)        (dec)
+    0x1e116000      63
+
+# nUtopiaPhyAdr   nUtopiaBusWidth      nPosPhyParity
+#                 default(16b) = 0     NA   = -1
+#                 8-bit        = 1     ODD  = 0
+#                 16-bit       = 2
+#
+#
+#    (hex)            (dec)                (dec)
+      0xFF              0                    0
+
+# bNtrEnable
+#
+#  (dec)
+    0" > /tmp/lowlevel.cfg
+}
+
+get_macaddr() {
+	local name
+	config_get name $1 name
+	[ "$name" = "dsl0" ] && config_get $2 $1 macaddr
+}
+
+service_triggers() {
+	procd_add_reload_trigger network
+}
+
+start_service() {
+	local annex
+	local firmware
+	local tone
+	local tone_adsl
+	local tone_vdsl
+	local xtse
+	local xfer_mode
+	local line_mode
+	local tc_layer
+	local mode
+	local lowlevel
+	local snr
+	local macaddr
+
+	config_load network
+	config_get tone dsl tone
+	config_get annex dsl annex
+	config_get firmware dsl firmware
+	config_get xfer_mode dsl xfer_mode
+	config_get line_mode dsl line_mode
+	config_get snr dsl ds_snr_offset
+	config_foreach get_macaddr device macaddr
+
+	eval "xtse=\"\${xtse_xdsl_$annex}\""
+
+	case "${xfer_mode}" in
+	atm)
+		tc_layer="-T1:0x1:0x1_1:0x1:0x1"
+		;;
+	ptm)
+		tc_layer="-T2:0x1:0x1_2:0x1:0x1"
+		;;
+	esac
+
+	case "${line_mode}" in
+	adsl)
+		mode="-M1"
+
+		# mask out VDSL bits when ADSL is requested
+		xtse="${xtse%_*}_00"
+		;;
+	vdsl)
+		mode="-M2"
+
+		# mask out ADSL bits when VDSL is requested
+		xtse="00_00_00_00_00_00_00_${xtse##*_}"
+		;;
+	esac
+
+	[ -z "${firmware}" ] && firmware=/lib/firmware/vdsl.bin
+	[ -f "${firmware}" ] || {
+		echo failed to find $firmware
+		return 1
+	}
+
+	eval "tone_adsl=\"\${tone_adsl_$tone}\""
+	eval "tone_vdsl=\"\${tone_vdsl_$tone}\""
+	[ -n "${tone_adsl}" ] && [ -n "${tone_vdsl}" ] && {
+		lowlevel_cfg "${tone_adsl}" "${tone_vdsl}"
+		lowlevel="-l /tmp/lowlevel.cfg"
+	}
+
+	[ -z "${snr}" ] && snr=0
+	[ -z "${macaddr}" ] && macaddr="00:00:00:00:00:00"
+	autoboot_script "$snr" "$macaddr"
+	autoboot="-a /tmp/dsl.scr -A /tmp/dsl.scr"
+
+	procd_open_instance
+	procd_set_param command /sbin/vdsl_cpe_control \
+			-i$xtse \
+			-n /sbin/dsl_notify.sh \
+			-f ${firmware} \
+			$lowlevel \
+			${mode} \
+			${tc_layer} \
+			$autoboot
+	procd_close_instance
+}
+
+stop_service() {
+	DSL_NOTIFICATION_TYPE="DSL_INTERFACE_STATUS" \
+	DSL_INTERFACE_STATUS="DOWN" \
+		/sbin/dsl_notify.sh
+}
diff --git a/package/network/config/ltq-vdsl-vr11-app/files/dsl_cpe_pipe.sh b/package/network/config/ltq-vdsl-vr11-app/files/dsl_cpe_pipe.sh
new file mode 100755
index 0000000000..9002b7b316
--- /dev/null
+++ b/package/network/config/ltq-vdsl-vr11-app/files/dsl_cpe_pipe.sh
@@ -0,0 +1,18 @@
+#!/bin/sh
+
+pipe_no=0
+
+# use specified pipe no
+case "$1" in
+0|1|2)
+pipe_no=$1; shift; ;;
+esac
+
+
+#echo "Call dsl_pipe with $*"
+lock /var/lock/dsl_pipe
+echo $* > /tmp/pipe/dsl_cpe${pipe_no}_cmd
+result=$(cat /tmp/pipe/dsl_cpe${pipe_no}_ack)
+lock -u /var/lock/dsl_pipe
+
+echo "$result"
diff --git a/package/network/config/ltq-vdsl-vr11-app/patches/100-compat.patch b/package/network/config/ltq-vdsl-vr11-app/patches/100-compat.patch
new file mode 100644
index 0000000000..6bc359c3cc
--- /dev/null
+++ b/package/network/config/ltq-vdsl-vr11-app/patches/100-compat.patch
@@ -0,0 +1,11 @@
+--- a/src/dsl_cpe_init_cfg.c
++++ b/src/dsl_cpe_init_cfg.c
+@@ -38,7 +38,7 @@ DSL_InitData_t gInitCfgData =
+       DSL_DEV_HS_TONE_GROUP_CLEANED, \
+       DSL_DEV_HS_TONE_GROUP_CLEANED, \
+       DSL_DEV_HS_TONE_GROUP_CLEANED, \
+-      0x1E116000, 0x37, -1),
++      0x1E116000, 0x3f, -1),
+    DSL_CPE_SIC_SET(DSL_TC_ATM, DSL_EMF_TC_CLEANED, DSL_EMF_TC_CLEANED, DSL_SYSTEMIF_MII, \
+                    DSL_TC_EFM, DSL_EMF_TC_CLEANED, DSL_EMF_TC_CLEANED, DSL_SYSTEMIF_MII),
+    DSL_CPE_MAC_CFG_SET(DSL_EFM_SPEED_100, DSL_EFM_DUPLEX_FULL, DSL_EFM_FLOWCTRL_ON, DSL_EFM_AUTONEG_OFF, \
diff --git a/package/network/config/ltq-vdsl-vr11-app/patches/101-warnings.patch b/package/network/config/ltq-vdsl-vr11-app/patches/101-warnings.patch
new file mode 100644
index 0000000000..0c02bb17b7
--- /dev/null
+++ b/package/network/config/ltq-vdsl-vr11-app/patches/101-warnings.patch
@@ -0,0 +1,87 @@
+--- a/src/dsl_cpe_control.h
++++ b/src/dsl_cpe_control.h
+@@ -13,6 +13,8 @@
+ #ifndef _DSL_CPE_CONTROL_H
+ #define _DSL_CPE_CONTROL_H
+ 
++#include <string.h>
++
+ /** \defgroup DSL_CPE_CONTROL Lantiq DSL CPE API Control Application
+     Lists the entire modules to the DSL CPE_API Control Application.
+   @{ */
+--- a/src/dsl_cpe_safec_wrapper.h
++++ b/src/dsl_cpe_safec_wrapper.h
+@@ -23,7 +23,7 @@
+ #define cpe_control_vsnprintf_s vsnprintf_s
+ 
+ /* snprintf_s symbol is not exported in SafeC lib */
+-static int cpe_control_snprintf_s(char *dest,
++static inline int cpe_control_snprintf_s(char *dest,
+                                   size_t dmax,
+                                   const char *fmt,
+                                   ...)
+@@ -40,7 +40,7 @@ static int cpe_control_snprintf_s(char *
+ 
+ #else
+ 
+-#warning "Safe C library is not available!"
++//#warning "Safe C library is not available!"
+ 
+ #include <stddef.h>     /* size_t */
+ #include <stdarg.h>     /* va_list */
+@@ -55,7 +55,7 @@ static __inline__ size_t safec_wrapper_m
+ #define cpe_control_memset_s(dest, destsz, src, srcsz) memset(dest, src, safec_wrapper_min(destsz,srcsz))
+ #define cpe_control_strncpy_s(dest, destsz, src, srcsz) strncpy(dest, src, safec_wrapper_min(destsz,srcsz))
+ 
+-static size_t cpe_control_strnlen_s(const char *str,
++static inline size_t cpe_control_strnlen_s(const char *str,
+                                     size_t smax)
+ {
+    /* preconditions */
+@@ -74,7 +74,7 @@ static size_t cpe_control_strnlen_s(cons
+    return size;
+ }
+ 
+-static char *cpe_control_strtok_s(char *dest,
++static inline char *cpe_control_strtok_s(char *dest,
+                                   size_t *dmax,
+                                   const char *delim,
+                                   char **ptr)
+@@ -123,7 +123,7 @@ static char *cpe_control_strtok_s(char *
+    return pTmp;
+ }
+ 
+-static int cpe_control_pipe_strcat_s(char *dest,
++static inline int cpe_control_pipe_strcat_s(char *dest,
+                                      size_t destsz,
+                                      char *src)
+ {
+@@ -157,7 +157,7 @@ static int cpe_control_pipe_strcat_s(cha
+    return 0;
+ }
+ 
+-static int cpe_control_snprintf_s(char *dest,
++static inline int cpe_control_snprintf_s(char *dest,
+                                   size_t dmax,
+                                   const char *fmt,
+                                   ...)
+@@ -181,7 +181,7 @@ static int cpe_control_snprintf_s(char *
+    return retVal;
+ }
+ 
+-static int cpe_control_vsnprintf_s(char *dest,
++static inline int cpe_control_vsnprintf_s(char *dest,
+                                    size_t dmax,
+                                    const char *fmt,
+                                    va_list vlist)
+--- a/tools/pipe/dsl_cpe_safec_wrapper.h
++++ b/tools/pipe/dsl_cpe_safec_wrapper.h
+@@ -27,7 +27,7 @@
+ 
+ #else
+ 
+-#warning "Safe C library is not available!"
++//#warning "Safe C library is not available!"
+ 
+ #include <stddef.h>	/* size_t */
+ static __inline__ size_t safec_wrapper_min(size_t a, size_t b)
diff --git a/package/network/config/ltq-vdsl-vr11-app/patches/200-autoboot.patch b/package/network/config/ltq-vdsl-vr11-app/patches/200-autoboot.patch
new file mode 100644
index 0000000000..c3e9b96620
--- /dev/null
+++ b/package/network/config/ltq-vdsl-vr11-app/patches/200-autoboot.patch
@@ -0,0 +1,85 @@
+This enables automatic connection after the control daemon is started,
+and also changes the way the connection is stopped on termination.
+
+Using the autoboot restart command is necessary because the stop command
+would stop the autoboot thread, and the driver offers no working way to
+start it again later, short of unloading and reloading the module.
+
+--- a/src/dsl_cpe_init_cfg.c
++++ b/src/dsl_cpe_init_cfg.c
+@@ -27,7 +27,7 @@ DSL_InitData_t gInitCfgData =
+    DSL_CPE_FW2_SET(DSL_NULL, 0x0),
+    DSL_CPE_XTU_SET(0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7),
+    DSL_CPE_LINE_INV_NE_SET(DSL_NULL),
+-   DSL_CPE_AUTOBOOT_CTRL_SET(DSL_AUTOBOOT_CTRL_STOP),
++   DSL_CPE_AUTOBOOT_CTRL_SET(DSL_AUTOBOOT_CTRL_START),
+    DSL_CPE_AUTOBOOT_CFG_SET(DSL_FALSE, DSL_FALSE, DSL_FALSE),
+    DSL_CPE_TEST_MODE_CTRL_SET(DSL_TESTMODE_DISABLE),
+    DSL_CPE_LINE_ACTIVATE_CTRL_SET(DSL_G997_INHIBIT_LDSF, DSL_G997_INHIBIT_ACSF, DSL_G997_NORMAL_STARTUP),
+--- a/src/dsl_cpe_control.c
++++ b/src/dsl_cpe_control.c
+@@ -7338,6 +7338,7 @@ DSL_CPE_STATIC  DSL_void_t DSL_CPE_Termi
+ {
+    DSL_Error_t nRet = DSL_SUCCESS;
+    DSL_int_t nDevice = 0;
++   DSL_AutobootConfig_t sAutobootCfg;
+    DSL_AutobootControl_t sAutobootCtl;
+    DSL_CPE_Control_Context_t *pCtrlCtx = DSL_NULL;
+ 
+@@ -7349,8 +7350,32 @@ DSL_CPE_STATIC  DSL_void_t DSL_CPE_Termi
+ 
+    for (nDevice = 0; nDevice < DSL_CPE_DSL_ENTITIES; ++nDevice)
+    {
++      g_bWaitBeforeConfigWrite[nDevice]    = DSL_TRUE;
++      g_bWaitBeforeLinkActivation[nDevice] = DSL_TRUE;
++      g_bWaitBeforeRestart[nDevice]        = DSL_TRUE;
++
++      g_bAutoContinueWaitBeforeConfigWrite[nDevice]    = DSL_FALSE;
++      g_bAutoContinueWaitBeforeLinkActivation[nDevice] = DSL_FALSE;
++      g_bAutoContinueWaitBeforeRestart[nDevice]        = DSL_FALSE;
++
++      memset(&sAutobootCfg, 0x0, sizeof(DSL_AutobootConfig_t));
++      sAutobootCfg.data.nStateMachineOptions.bWaitBeforeConfigWrite    = DSL_TRUE;
++      sAutobootCfg.data.nStateMachineOptions.bWaitBeforeLinkActivation = DSL_TRUE;
++      sAutobootCfg.data.nStateMachineOptions.bWaitBeforeRestart        = DSL_TRUE;
++
++      nRet = (DSL_Error_t)DSL_CPE_Ioctl(
++         DSL_CPE_GetGlobalContext()->fd[nDevice],
++         DSL_FIO_AUTOBOOT_CONFIG_SET, (DSL_int_t)&sAutobootCfg);
++
++      if (nRet < DSL_SUCCESS)
++      {
++         DSL_CCA_DEBUG(DSL_CCA_DBG_ERR, (DSL_CPE_PREFIX
++            "Autoboot configuration for device (%d) failed!, nRet = %d!"
++            DSL_CPE_CRLF, nDevice, sAutobootCtl.accessCtl.nReturn));
++      }
++
+       memset(&sAutobootCtl, 0, sizeof(DSL_AutobootControl_t));
+-      sAutobootCtl.data.nCommand = DSL_AUTOBOOT_CTRL_STOP;
++      sAutobootCtl.data.nCommand = DSL_AUTOBOOT_CTRL_RESTART;
+ 
+       nRet = (DSL_Error_t)DSL_CPE_Ioctl(
+          DSL_CPE_GetGlobalContext()->fd[nDevice],
+@@ -7359,13 +7384,13 @@ DSL_CPE_STATIC  DSL_void_t DSL_CPE_Termi
+       if (nRet < DSL_SUCCESS)
+       {
+          DSL_CCA_DEBUG(DSL_CCA_DBG_ERR, (DSL_CPE_PREFIX
+-            "Autoboot stop for device (%d) failed!, nRet = %d!"
++            "Autoboot restart for device (%d) failed!, nRet = %d!"
+             DSL_CPE_CRLF, nDevice, sAutobootCtl.accessCtl.nReturn));
+       }
+    }
+ 
+    DSL_CCA_DEBUG(DSL_CCA_DBG_MSG, (DSL_CPE_PREFIX
+-      "Autoboot stop executed" DSL_CPE_CRLF));
++      "Autoboot restart executed" DSL_CPE_CRLF));
+ 
+    DSL_CPE_DaemonExit();
+ 
+@@ -8798,4 +8823,4 @@ DSL_CPE_STATIC DSL_Error_t DSL_CPE_Firmw
+       pDecimal));
+ 
+    return nErrCode;
+-}
+\ No newline at end of file
++}
diff --git a/package/network/config/ltq-vdsl-vr11-app/patches/300-ubus.patch b/package/network/config/ltq-vdsl-vr11-app/patches/300-ubus.patch
new file mode 100644
index 0000000000..fc0dd70bc1
--- /dev/null
+++ b/package/network/config/ltq-vdsl-vr11-app/patches/300-ubus.patch
@@ -0,0 +1,50 @@
+--- a/src/dsl_cpe_control.c
++++ b/src/dsl_cpe_control.c
+@@ -221,6 +221,9 @@ extern DSL_Error_t DSL_CPE_Pipe_StaticRe
+ #endif /* INCLUDE_DSL_RESOURCE_STATISTICS*/
+ #endif
+ 
++extern void ubus_init();
++extern void ubus_deinit();
++
+ DSL_char_t *g_sFirmwareName1 = DSL_NULL;
+ DSL_FirmwareFeatures_t g_nFwFeatures1 = {DSL_FW_XDSLMODE_CLEANED, DSL_FW_XDSLFEATURE_CLEANED,
+    DSL_FW_XDSLFEATURE_CLEANED};
+@@ -7831,6 +7834,8 @@ DSL_int_t dsl_cpe_daemon (
+ #endif /* defined(INCLUDE_DSL_JSON_PARSING) && (INCLUDE_DSL_JSON_PARSING == 1) */
+ #endif /* RTEMS*/
+ 
++   ubus_init();
++
+    /* Open DSL_CPE_MAX_DSL_ENTITIES devices*/
+    for (nDevice = 0; nDevice < DSL_CPE_DSL_ENTITIES; nDevice++)
+    {
+@@ -8367,6 +8372,7 @@ DSL_int_t dsl_cpe_daemon (
+ #endif /* INCLUDE_DSL_CPE_CLI_SUPPORT */
+ 
+ DSL_CPE_CONTROL_EXIT:
++   ubus_deinit();
+ 
+    if (INCLUDE_DSL_BONDING)
+    {
+--- a/src/Makefile.am
++++ b/src/Makefile.am
+@@ -17,7 +17,7 @@ else
+ dsl_cpe_control_common_ldflags =
+ endif
+ 
+-dsl_cpe_control_LDADD = -lpthread -lrt
++dsl_cpe_control_LDADD = -lpthread -lrt -lubox -lubus
+ 
+ if INCLUDE_DSL_CPE_DTI_SUPPORT
+ dsl_cpe_control_LDADD += -ldti_agent
+@@ -118,7 +118,8 @@ dsl_cpe_control_SOURCES = \
+ 	dsl_cpe_control.c \
+ 	dsl_cpe_init_cfg.c \
+ 	dsl_cpe_linux.c \
+-	dsl_cpe_debug.c
++	dsl_cpe_debug.c \
++	dsl_cpe_ubus.c
+ 
+ dsl_cpe_control_SOURCES += \
+ 	$(dsl_cpe_control_dti_sources)




More information about the lede-commits mailing list